> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gable.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Get contract Constraints

> Get contract Constraints



## OpenAPI

````yaml /api-reference/bundled.yaml get /v0/contract_constraints
openapi: 3.1.0
info:
  title: Gable API
  description: >
    API to interact with the Gable platform

    ## Authorization

    All API requests require an API key to be passed in the `X-API-KEY` header.
    For instructions on finding your API key and api endpoint check out the [API
    Key documentation](../docs/api-keys.md).

    Example: `curl -H "X-API-KEY: <your-api-key>"
    https://api-{organization}.gable.ai/v0/ping`
  contact:
    name: Gable Engineering
    url: https://gable.ai
    email: engineers@gable.ai
  version: 1.28.0
servers:
  - url: https://{hostname}.gable.ai
    description: Gable API
    variables:
      hostname:
        default: demo-api
        description: Customer environment assigned by Gable
security:
  - ApiKeyAuth: []
tags:
  - name: action
  - name: api-keys
  - name: auth
  - name: changelog
  - name: config
  - name: contract
  - name: data-asset
  - name: debug
  - name: s3
  - name: settings
  - name: slack
  - name: sso
  - name: webhook
  - name: notifications
  - name: constraints
  - name: telemetry
  - name: component
  - name: components
  - name: sca
  - name: cross-service-components
  - name: lineage
  - name: events
  - name: measurements
  - name: defect-report
  - name: experimental
paths:
  /v0/contract_constraints:
    get:
      tags:
        - constraints
      summary: Get contract Constraints
      description: Get contract Constraints
      operationId: getContractConstraints
      responses:
        '200':
          description: constraints
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ContractConstraintMapping'
components:
  schemas:
    ContractConstraintMapping:
      type: object
      description: >-
        Mapping of contract constraint types to their respective recap type
        constraint categories and detailed constraint definitions
      additionalProperties:
        $ref: '#/components/schemas/ContractConstraint'
      components:
        schemas:
          ContractConstraint:
            type: object
            oneOf:
              - $ref: '#/components/schemas/TimeConstraints'
              - $ref: '#/components/schemas/FloatConstraints'
              - $ref: '#/components/schemas/IntegerConstraints'
              - $ref: '#/components/schemas/ListConstraints'
              - $ref: '#/components/schemas/MapConstraints'
              - $ref: '#/components/schemas/StringConstraints'
              - $ref: '#/components/schemas/UUIDConstraints'
              - $ref: '#/components/schemas/BooleanConstraints'
              - $ref: '#/components/schemas/OtherConstraints'
              - $ref: '#/components/schemas/RecapConstraints'
              - $ref: '#/components/schemas/SupportedContractConstraints'
            discriminator:
              propertyName: type
              mapping:
                time: '#/components/schemas/TimeConstraints'
                float: '#/components/schemas/FloatConstraints'
                integer: '#/components/schemas/IntegerConstraints'
                list: '#/components/schemas/ListConstraints'
                map: '#/components/schemas/MapConstraints'
                string: '#/components/schemas/StringConstraints'
                uuid: '#/components/schemas/UUIDConstraints'
                boolean: '#/components/schemas/BooleanConstraints'
                other: '#/components/schemas/OtherConstraints'
                recap: '#/components/schemas/RecapConstraints'
                contract: '#/components/schemas/SupportedContractConstraints'
          LengthConstraintEnum:
            type: string
            enum:
              - length
              - isNotEmpty
              - isNull
              - isNullThreshold
          RecapTypeConstraintCategory:
            type: string
            enum:
              - NUMBER
              - TIME
              - STRING
              - BYTES
              - DATA_STRUCTURE
              - OTHER
          ContractConstraintType:
            type: string
            enum:
              - greaterThan
              - greaterThanOrEqualTo
              - lessThan
              - lessThanOrEqualTo
              - isNull
              - isNullThreshold
              - charLength
              - isNotEmpty
              - length
            x-enum-varnames:
              - GREATER_THAN
              - GREATER_THAN_OR_EQUAL_TO
              - LESS_THAN
              - LESS_THAN_OR_EQUAL_TO
              - IS_NULL
              - IS_NULL_THRESHOLD
              - CHARACTER_LENGTH
              - IS_NOT_EMPTY
              - LENGTH
          NumberConstraintEnum:
            type: string
            enum:
              - greaterThan
              - greaterThanOrEqualTo
              - lessThan
              - lessThanOrEqualTo
              - isNull
              - isNullThreshold
          StringConstraintEnum:
            type: string
            enum:
              - charLength
              - isNotEmpty
              - isNull
              - isNullThreshold
          OtherConstraintEnum:
            type: string
            enum:
              - isNull
              - isNullThreshold
          TimeConstraints:
            type: object
            required:
              - type
              - constraints
            properties:
              type:
                type: string
                enum:
                  - time
              constraints:
                type: array
                items:
                  $ref: '#/components/schemas/NumberConstraintEnum'
          FloatConstraints:
            type: object
            required:
              - type
              - constraints
            properties:
              type:
                type: string
                enum:
                  - float
              constraints:
                type: array
                items:
                  $ref: '#/components/schemas/NumberConstraintEnum'
          IntegerConstraints:
            type: object
            required:
              - type
              - constraints
            properties:
              type:
                type: string
                enum:
                  - integer
              constraints:
                type: array
                items:
                  $ref: '#/components/schemas/NumberConstraintEnum'
          ListConstraints:
            type: object
            required:
              - type
              - constraints
            properties:
              type:
                type: string
                enum:
                  - list
              constraints:
                type: array
                items:
                  $ref: '#/components/schemas/LengthConstraintEnum'
          MapConstraints:
            type: object
            required:
              - type
              - constraints
            properties:
              type:
                type: string
                enum:
                  - map
              constraints:
                type: array
                items:
                  $ref: '#/components/schemas/LengthConstraintEnum'
          StringConstraints:
            type: object
            required:
              - type
              - constraints
            properties:
              type:
                type: string
                enum:
                  - string
              constraints:
                type: array
                items:
                  $ref: '#/components/schemas/StringConstraintEnum'
          UUIDConstraints:
            type: object
            required:
              - type
              - constraints
            properties:
              type:
                type: string
                enum:
                  - uuid
              constraints:
                type: array
                items:
                  $ref: '#/components/schemas/StringConstraintEnum'
          OtherConstraints:
            type: object
            required:
              - type
              - constraints
            properties:
              type:
                type: string
                enum:
                  - other
              constraints:
                type: array
                items:
                  $ref: '#/components/schemas/OtherConstraintEnum'
          BooleanConstraints:
            type: object
            required:
              - type
              - constraints
            properties:
              type:
                type: string
                enum:
                  - boolean
              constraints:
                type: array
                items:
                  $ref: '#/components/schemas/OtherConstraintEnum'
          RecapConstraints:
            type: object
            required:
              - type
              - constraints
            properties:
              type:
                type: string
                enum:
                  - recap
              constraints:
                type: array
                items:
                  $ref: '#/components/schemas/RecapTypeConstraintCategory'
          SupportedContractConstraints:
            type: object
            required:
              - type
              - constraints
            properties:
              type:
                type: string
                enum:
                  - contract
              constraints:
                type: array
                items:
                  $ref: '#/components/schemas/ContractConstraintType'
    ContractConstraint:
      type: object
      oneOf:
        - $ref: '#/components/schemas/TimeConstraints'
        - $ref: '#/components/schemas/FloatConstraints'
        - $ref: '#/components/schemas/IntegerConstraints'
        - $ref: '#/components/schemas/ListConstraints'
        - $ref: '#/components/schemas/MapConstraints'
        - $ref: '#/components/schemas/StringConstraints'
        - $ref: '#/components/schemas/UUIDConstraints'
        - $ref: '#/components/schemas/BooleanConstraints'
        - $ref: '#/components/schemas/OtherConstraints'
        - $ref: '#/components/schemas/RecapConstraints'
        - $ref: '#/components/schemas/SupportedContractConstraints'
      discriminator:
        propertyName: type
        mapping:
          time:
            $ref: '#/components/schemas/TimeConstraints'
          float:
            $ref: '#/components/schemas/FloatConstraints'
          integer:
            $ref: '#/components/schemas/IntegerConstraints'
          list:
            $ref: '#/components/schemas/ListConstraints'
          map:
            $ref: '#/components/schemas/MapConstraints'
          string:
            $ref: '#/components/schemas/StringConstraints'
          uuid:
            $ref: '#/components/schemas/UUIDConstraints'
          boolean:
            $ref: '#/components/schemas/BooleanConstraints'
          other:
            $ref: '#/components/schemas/OtherConstraints'
          recap:
            $ref: '#/components/schemas/RecapConstraints'
          contract:
            $ref: '#/components/schemas/SupportedContractConstraints'
    TimeConstraints:
      type: object
      required:
        - type
        - constraints
      properties:
        type:
          type: string
          enum:
            - time
        constraints:
          type: array
          items:
            $ref: '#/components/schemas/NumberConstraintEnum'
    FloatConstraints:
      type: object
      required:
        - type
        - constraints
      properties:
        type:
          type: string
          enum:
            - float
        constraints:
          type: array
          items:
            $ref: '#/components/schemas/NumberConstraintEnum'
    IntegerConstraints:
      type: object
      required:
        - type
        - constraints
      properties:
        type:
          type: string
          enum:
            - integer
        constraints:
          type: array
          items:
            $ref: '#/components/schemas/NumberConstraintEnum'
    ListConstraints:
      type: object
      required:
        - type
        - constraints
      properties:
        type:
          type: string
          enum:
            - list
        constraints:
          type: array
          items:
            $ref: '#/components/schemas/LengthConstraintEnum'
    MapConstraints:
      type: object
      required:
        - type
        - constraints
      properties:
        type:
          type: string
          enum:
            - map
        constraints:
          type: array
          items:
            $ref: '#/components/schemas/LengthConstraintEnum'
    StringConstraints:
      type: object
      required:
        - type
        - constraints
      properties:
        type:
          type: string
          enum:
            - string
        constraints:
          type: array
          items:
            $ref: '#/components/schemas/StringConstraintEnum'
    UUIDConstraints:
      type: object
      required:
        - type
        - constraints
      properties:
        type:
          type: string
          enum:
            - uuid
        constraints:
          type: array
          items:
            $ref: '#/components/schemas/StringConstraintEnum'
    BooleanConstraints:
      type: object
      required:
        - type
        - constraints
      properties:
        type:
          type: string
          enum:
            - boolean
        constraints:
          type: array
          items:
            $ref: '#/components/schemas/OtherConstraintEnum'
    OtherConstraints:
      type: object
      required:
        - type
        - constraints
      properties:
        type:
          type: string
          enum:
            - other
        constraints:
          type: array
          items:
            $ref: '#/components/schemas/OtherConstraintEnum'
    RecapConstraints:
      type: object
      required:
        - type
        - constraints
      properties:
        type:
          type: string
          enum:
            - recap
        constraints:
          type: array
          items:
            $ref: '#/components/schemas/RecapTypeConstraintCategory'
    SupportedContractConstraints:
      type: object
      required:
        - type
        - constraints
      properties:
        type:
          type: string
          enum:
            - contract
        constraints:
          type: array
          items:
            $ref: '#/components/schemas/ContractConstraintType'
    NumberConstraintEnum:
      type: string
      enum:
        - greaterThan
        - greaterThanOrEqualTo
        - lessThan
        - lessThanOrEqualTo
        - isNull
        - isNullThreshold
    LengthConstraintEnum:
      type: string
      enum:
        - length
        - isNotEmpty
        - isNull
        - isNullThreshold
    StringConstraintEnum:
      type: string
      enum:
        - charLength
        - isNotEmpty
        - isNull
        - isNullThreshold
    OtherConstraintEnum:
      type: string
      enum:
        - isNull
        - isNullThreshold
    RecapTypeConstraintCategory:
      type: string
      enum:
        - NUMBER
        - TIME
        - STRING
        - BYTES
        - DATA_STRUCTURE
        - OTHER
    ContractConstraintType:
      type: string
      enum:
        - greaterThan
        - greaterThanOrEqualTo
        - lessThan
        - lessThanOrEqualTo
        - isNull
        - isNullThreshold
        - charLength
        - isNotEmpty
        - length
      x-enum-varnames:
        - GREATER_THAN
        - GREATER_THAN_OR_EQUAL_TO
        - LESS_THAN
        - LESS_THAN_OR_EQUAL_TO
        - IS_NULL
        - IS_NULL_THRESHOLD
        - CHARACTER_LENGTH
        - IS_NOT_EMPTY
        - LENGTH
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: X-API-KEY

````